//
//  PickerViewController.swift
//  TextLCD
//
//  Created by Phidgets on 2018-02-02.
//  Copyright © 2018 Phidgets. All rights reserved.
//

import UIKit
import Phidget22Swift

class PickerViewController: UIViewController, UIPickerViewDelegate, UIPickerViewDataSource {
    
    @IBOutlet var pickerTitle: UILabel!
    @IBOutlet var pickerBox: UIView!
    @IBOutlet var pickerView: UIPickerView!
    var pickerArray = [String]()
    var titleName = String()
    var ch = LCD()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        pickerBox.layer.cornerRadius = 5
        pickerBox.layer.masksToBounds = true
        pickerTitle.text = titleName
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        return pickerArray.count
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        return pickerArray[row]
    }
    
    func pickerView(_ pickerView: UIPickerView, viewForRow row: Int, forComponent component: Int, reusing view: UIView?) -> UIView {
        var text = (view as? UILabel)
        if text == nil{
            text = UILabel.init()
        }
        text?.font = UIFont.systemFont(ofSize: 25, weight: UIFont.Weight.light)
        text?.textAlignment = .center
        text?.adjustsFontSizeToFitWidth = true
        text?.text = self.pickerView(pickerView, titleForRow: row, forComponent: component)
        
        return text!
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        let resultString:String = (pickerArray[row])
        do{
            if(resultString == "dimensions_1x8"){
                try ch.setScreenSize(LCDScreenSize.dimensions_1x8)
            }
            else if (resultString == "dimensions_2x8"){
                try ch.setScreenSize(LCDScreenSize.dimensions_2x8)
            }
            else if (resultString == "dimensions_1x16"){
                try ch.setScreenSize(LCDScreenSize.dimensions_1x16)
            }
            else if (resultString == "dimensions_2x16"){
                try ch.setScreenSize(LCDScreenSize.dimensions_2x16)
            }
            else if (resultString == "dimensions_4x16"){
                try ch.setScreenSize(LCDScreenSize.dimensions_4x16)
            }
            else if (resultString == "dimensions_2x20"){
                try ch.setScreenSize(LCDScreenSize.dimensions_2x20)
            }
            else if (resultString == "dimensions_4x20"){
                try ch.setScreenSize(LCDScreenSize.dimensions_4x20)
            }
            else if (resultString == "dimensions_2x24"){
                try ch.setScreenSize(LCDScreenSize.dimensions_2x24)
            }
            else if (resultString == "dimensions_1x40"){
                try ch.setScreenSize(LCDScreenSize.dimensions_1x40)
            }
            else if (resultString == "dimensions_2x40"){
                try ch.setScreenSize(LCDScreenSize.dimensions_2x40)
            }
            else if (resultString == "dimensions_4x40"){
                try ch.setScreenSize(LCDScreenSize.dimensions_4x40)
            }
        } catch let err as PhidgetError {
            outputErrorMessage(errorTitle: "Error Code: \(err.errorCode)", errorMessage: err.description)
        } catch {
            print (error)
        }
        
    }
    
    var timeStamp:TimeInterval = 0
    var lastTimeStamp:TimeInterval = 0
    func outputErrorMessage(errorTitle:String, errorMessage:String){
        timeStamp = NSDate.timeIntervalSinceReferenceDate
        //Add a delay for error events so the user does not get bombarded by error events
        if(timeStamp - lastTimeStamp > 5){
            let alert = UIAlertController(title: errorTitle, message: errorMessage, preferredStyle: .alert)
            alert.addAction(UIAlertAction(title: "OK", style: .default, handler: {action -> Void in
            }))
            self.present(alert, animated: true, completion: nil)
            lastTimeStamp = timeStamp
        }
    }
    
}
